unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, voicerlibLib_TLB, ExtCtrls, ShellApi;

type
  TForm1 = class(TForm)
    Opcoes: TGroupBox;
    lblMensagem: TLabel;
    txtMensagem: TEdit;
    lblMindigitos: TLabel;
    txtMindigitos: TEdit;
    lblMaxdigitos: TLabel;
    txtMaxdigitos: TEdit;
    lblDigitosterminadores: TLabel;
    txtDigitosterminadores: TEdit;
    lblTomeoutglobal: TLabel;
    txtTimeoutglobal: TEdit;
    lblTimeoutinterdigito: TLabel;
    txtTimeoutinterdigito: TEdit;
    chkReproducao: TCheckBox;
    lblNumerodetentativas: TLabel;
    txtNumerodetentativas: TEdit;
    GroupBox1: TGroupBox;
    lblConfirmacao: TLabel;
    txtConfirmacao: TEdit;
    lblTentar: TLabel;
    txtTentar: TEdit;
    lblAceitar: TLabel;
    txtAceitar: TEdit;
    lblDescartar: TLabel;
    txtDescartar: TEdit;
    memLog: TMemo;
    Label1: TLabel;
    Panel1: TPanel;
    Label3: TLabel;
    Label2: TLabel;
    txtPorta: TEdit;
    lblNumPortas: TLabel;
    Panel2: TPanel;
    cmdAtender: TButton;
    cmdPrompt: TButton;
    cmdDesligar: TButton;
    chkAuto: TCheckBox;
    Button1: TButton;
    chkConfirmacao: TCheckBox;
    lblConferencia: TLabel;
    txtVerificacao: TEdit;
    btnEnable: TButton;
    btnDisable: TButton;
    vlib4: Tvoicerlib;
    Image1: TImage;
    btnLimpa: TButton;
    procedure chkReproducaoClick(Sender: TObject);
    procedure chkConfirmacaoClick(Sender: TObject);
    procedure cmdAtenderClick(Sender: TObject);
    procedure cmdDesligarClick(Sender: TObject);
    procedure cmdPromptClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure vLib4Prompt(ASender: TObject; Port: Smallint;
      const Value: WideString; Status: Smallint);
    procedure vLib4RingDetected(ASender: TObject; Port: Smallint);
    procedure vLib4AfterPickup(ASender: TObject; Port: Smallint);
    procedure btnLimpaClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure vLib4PlayStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure vLib4BusyDetected(ASender: TObject; Port: Smallint);
    function cpf(num: string): boolean;
    procedure btnEnableClick(Sender: TObject);
    procedure btnDisableClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
    procedure GeraLog(nPorta: Integer; sMsg: String);
  public
    { Public declarations }

  end;

var
  Form1: TForm1;
  bComPlayBack, bComConfirmacao: Boolean;
  status_ok: boolean;
  nPorta : Integer;
  sReturn    : array [0..255] of Char;

implementation

{$R *.DFM}

// Funcao que valida CPF
function TForm1.cpf(num: string): boolean;
var
  n1,n2,n3,n4,n5,n6,n7,n8,n9: integer;
  d1,d2: integer;
  digitado, calculado: string;
begin
  n1:=StrToInt(num[1]);
  n2:=StrToInt(num[2]);
  n3:=StrToInt(num[3]);
  n4:=StrToInt(num[4]);
  n5:=StrToInt(num[5]);
  n6:=StrToInt(num[6]);
  n7:=StrToInt(num[7]);
  n8:=StrToInt(num[8]);
  n9:=StrToInt(num[9]);
  d1:=n9*2+n8*3+n7*4+n6*5+n5*6+n4*7+n3*8+n2*9+n1*10;
  d1:=11-(d1 mod 11);
  if d1>=10 then
    d1:=0;
  d2:=d1*2+n9*3+n8*4+n7*5+n6*6+n5*7+n4*8+n3*9+n2*10+n1*11;
  d2:=11-(d2 mod 11);
  if d2>=10 then
    d2:=0;
  calculado:=inttostr(d1)+inttostr(d2);
  digitado:=num[10]+num[11];
  if calculado=digitado then
    cpf:=true
  else
    cpf:=false;
end;

procedure TForm1.chkReproducaoClick(Sender: TObject);
begin

  bComPlayBack := False;
  txtVerificacao.Enabled := False;

  if chkReproducao.Checked then
  begin
    bComPlayBack := True;
    txtVerificacao.Enabled := True;
  end;
end;

procedure TForm1.chkConfirmacaoClick(Sender: TObject);
begin

  bComConfirmacao := False;
  txtConfirmacao.Enabled := False;

  if chkConfirmacao.Checked then
  begin
    bComConfirmacao := True;
    txtConfirmacao.Enabled := True;
    txtVerificacao.Enabled := True;
  end;
end;

procedure TForm1.cmdAtenderClick(Sender: TObject);
var
  nRet: Integer;
begin

  //Atende a ligao
  nRet := vLib4.PickUp(nPorta, 100);

  //Testa se atendeu corretamente
  if nRet = DG_EXIT_SUCCESS then
  begin
    cmdAtender.Enabled := False;
    cmdDesligar.Enabled := True;
    GeraLog(nPorta, 'Atendeu com sucesso');
  end
  else
    GeraLog(nPorta, 'Erro ao Atender');

end;

procedure TForm1.cmdDesligarClick(Sender: TObject);
var
  nRet: Integer;
begin
  // Desliga a ligao
  nRet := vLib4.HangUp(nPorta);

  //Testa se desligou corretamente
  if nRet = DG_EXIT_SUCCESS then
  begin
    cmdAtender.Enabled := True;
    GeraLog(nPorta, 'Desligou com sucesso!');
  end
  else
    GeraLog(nPorta, 'Erro ao Desligar. Cdigo: ' + IntToStr(nRet));

  //Interrompe a funcao de PromptStart
  vLib4.PromptAbort(nPorta);
  
end;

procedure TForm1.cmdPromptClick(Sender: TObject);
var
  nRet: Integer;
  nRet1: Integer;
begin

  if txtMensagem.Text = '' then
  begin
    ShowMessage('Informe a mensagem do prompt');
    exit;
  end;

  //Apaga o contedo do buffer de dgitos de cada canal
  vLib4.ClearDigits(nPorta);
  GeraLog(nPorta, 'ClearDigits...');

  //Configura as opes de prompt
  nRet1 := vLib4.PromptSettings(nPorta, Trim(txtVerificacao.text), Trim(txtConfirmacao.Text),
                                Trim(txtTentar.Text),Trim(txtAceitar.Text), Trim(txtDescartar.Text));

  if nRet1 <> DG_EXIT_SUCCESS then
    GeraLog(nPorta, 'Erro no Prompt Settings')
  else
    GeraLog(nPorta, 'PromptSettings configurado com sucesso');

  //Habilita deteccao de DTMF
  vlib4.SetDetectionType(nPorta, DETECT_DTMF,DG_ENABLE);

  //Se estiver configurado '@' reproduz a lista de mensagem existente no PlayListAdd
  if txtMensagem.text='@' then
  begin
    vlib4.PlayListClear(nPorta);
    vlib4.PlayListAdd(nPorta,ptFile,ExtractFilePath(Application.ExeName) + 'cpf.wav','',10);
  end;

  //Inicio do Prompt
  nRet := vLib4.PromptStart(nPorta, Trim(txtMensagem.Text), StrToInt(txtMindigitos.text),
                            StrToInt(txtMaxdigitos.text), StrToInt(txtTimeoutglobal.Text),
                            StrToInt(txtTimeoutinterdigito.Text), Trim(txtDigitosterminadores.Text),
                            bComConfirmacao, bcomPlayBack, StrToInt(txtNumerodeTentativas.Text), False, 0);

  //Testa se executou corretamente o Prompt
  if nRet = DG_EXIT_SUCCESS then
  begin
    GeraLog(nPorta, 'Executando Prompt');
    status_ok := True;
  end
  else
    GeraLog(nPorta, 'Erro ao executar o Prompt');
end;


procedure TForm1.FormShow(Sender: TObject);
var
  nRet: Integer;
begin

  txtMensagem.Text    := ExtractFilePath(Application.ExeName) + 'cpf.wav';
  txtVerificacao.Text := ExtractFilePath(Application.ExeName) + 'vocedigitou.wav';
  txtConfirmacao.Text := ExtractFilePath(Application.ExeName) + 'confirmacao.wav';

  if chkConfirmacao.Checked = False Then
  begin
    bComConfirmacao := False;
    txtConfirmacao.Enabled := False;
  end
  else
  begin
    bComConfirmacao := True;
    txtConfirmacao.Enabled := True;
    txtVerificacao.Enabled := True;
  end;

  if chkReproducao.Checked= False then
  begin
    bComPlayBack := False;
    txtVerificacao.Enabled := False;
  end
  else
  begin
    bComPlayBack := True;
    txtVerificacao.Enabled := True;
  end;

  //Inicializa a placa
  nRet := vLib4.StartVoicerLib;
  //Trata o retorno da inicializacao
  vlib4.ReturnCodeToString(nRet,Cardinal(@sReturn));

  //Testa o Retorno da inicializao
  if nRet = DG_EXIT_SUCCESS then
    GeraLog(nPorta, 'Placa inicializada com sucesso')
  else
    GeraLog(nPorta, 'Erro na inicializao. Cdigo: ' + IntToStr(nRet) + ' (' + sReturn + ') ');

  //Apresenta na tela o nmero de portas disponiveis
  lblNumPortas.Caption := IntToStr(vlib4.GetPortsCount);
  //Seta o formato de reproduo da porta
  vLib4.SetPlayFormat(nPorta, ffWaveULaw);

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  nRet, nPortas: Integer;
begin

  if vLib4.DriverEnabled then
  begin
    if status_ok = True then
    begin
      for nPortas := 1 to vLib4.GetPortsCount do
      begin
        //Interrompe a execucao do PromptStart
        nRet := vLib4.PromptAbort(nPortas);
        if nRet <> DG_EXIT_SUCCESS then
          Application.MessageBox('Erro ao Finalizar o Prompt', 'Exemplo de Prompt - Erro', MB_OK,)
      end;
    end;

    //Interrompe alguma ligao que pode estar atendida
    cmdDesligarClick(Sender);

    //Desliga a Placa
    nRet := vLib4.ShutdownVoicerLib;

    //Testa se desligou corretamente
    if nRet = DG_EXIT_SUCCESS then
      GeraLog(nPorta, 'Placa finalizada com sucesso')
    else
      Application.MessageBox('Erro na finalizao. Recomenda-se reiniciar o micro.', 'Exemplo de Prompt - Erro', MB_OK,);
  end;
end;

procedure TForm1.vLib4Prompt(ASender: TObject; Port: Smallint;
  const Value: WideString; Status: Smallint);
var
  nRet : Integer;
  sCPF : String;
  bVal : Boolean ;
begin

  //Indica o resultado do Prompt
  case Status of

    mpAborted        : GeraLog(Port, 'Cancelado por Comando PromptAbort');

    mpRetriesExceeded:
    begin
      GeraLog(Port, 'Excedeu nmero de tentativas');
      nRet := Vlib4.PlayFile(StrToInt(txtPorta.Text), ExtractFilePath(Application.ExeName) + 'ATE_LOGO.wav','',0);
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(Port, 'Erro ao executar frase');
    end;

    mpOk             :
    begin
      GeraLog(Port, 'Recebido dgitos ' + Value);
      //Valida se o CPF esta correto
      sCPF := Value;
      bVal := cpf(sCPF);
      if bVal then
      begin
        GeraLog(Port,'CPF correto!!!!');
        nRet := Vlib4.PlayFile(Port, ExtractFilePath(Application.ExeName) + 'OBRIGADA.wav','',0);
        if nRet <> DG_EXIT_SUCCESS then
          GeraLog(Port, 'Erro ao executar frase');
      end
      else
      begin
        GeraLog(Port,'CPF incorreto!!!!');
        nRet := Vlib4.PlayFile(Port, ExtractFilePath(Application.ExeName) + 'NUM_INCORRETO.wav','',0);
        if nRet <> DG_EXIT_SUCCESS then
          GeraLog(Port, 'Erro ao executar frase');
      end;
    end;

    mpCanceled       :
    begin
      GeraLog(Port, 'Cancelado pelo Telefone');
      nRet := Vlib4.PlayFile(StrToInt(txtPorta.Text), ExtractFilePath(Application.ExeName) + 'ATE_LOGO.wav','',0);
      if nRet <> DG_EXIT_SUCCESS then
        GeraLog(Port, 'Erro ao executar frase');
    end;
  end;
end;

procedure TForm1.vLib4RingDetected(ASender: TObject; Port: Smallint);
begin
  nPorta := Port; //Armazena a porta que chegou ring
  GeraLog(Port, 'Ring...');
  if chkAuto.Checked then
    vLib4.PickUp(Port, 1000);
end;

procedure TForm1.vLib4AfterPickup(ASender: TObject; Port: Smallint);
begin
  cmdDesligar.Enabled := True;

  //So funciona se tiver o menu associado
  if chkAuto.Checked then
  begin
    cmdPrompt.Click;
  end;
end;

procedure TForm1.GeraLog(nPorta: Integer; sMsg: String);
begin
  try
    memLog.Lines.Add('<' + TimeToStr(Time) + '>' + IntToStr(nPorta) + ' -> ' + sMsg);
  except;
    Application.MessageBox('GeraLog', 'Except', mb_OK);
  end;
end;

procedure TForm1.btnLimpaClick(Sender: TObject);
begin
  memLog.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  L : String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt' ;
  ShellExecute(0, nil ,PChar(L), nil,nil,SW_NORMAL);
end;

procedure TForm1.vLib4PlayStop(ASender: TObject; Port,
  StopStatus: Smallint);
begin

  case StopStatus of
    ssNormal: GeraLog(nPorta,'OnPlayStop - Mensagem falada por completo');
    ssDigitReceived: GeraLog(nPorta,'OnPlayStop - Recebeu Digito');
    ssStopped : GeraLog(nPorta,'OnPlayStop - Mensagem foi interrompida pela chamada do mtodo StopPlayFile');
    ssAbnormal: GeraLog(nPorta,'OnPlayStop - Mensagem foi interrompida por causa de algum erro indeterminado');
  end;
end;

procedure TForm1.vLib4BusyDetected(ASender: TObject; Port: Smallint);
begin
  GeraLog(Port , 'Ocupado...');

  //Libera a linha conectada a placa (desliga)
  vLib4.HangUp(Port);
  GeraLog(Port, 'Desligou a porta...');

end;
procedure TForm1.btnEnableClick(Sender: TObject);
var
  nRet,i,j,k : Integer;
begin
  try
    for j:=1 to vlib4.GetPortsCount do
    begin
      //Cria thread do protocolo R2D
      nRet := vlib4.CreateE1Thread(j);

      case nRet of
        DG_EXIT_SUCCESS:
          GeraLog(j,'Thread E1 iniciada com sucesso');

        DG_ERROR_DRIVER_CLOSED:
          GeraLog(j,'O driver no foi iniciado');

        DG_ERROR_THREAD_ALREADY_RUNNING:
          GeraLog(j,'A thread j havia sido iniciada anteriormente');

        DG_FEATURE_NOT_SUPPORTED:
          GeraLog(j,'Comando enviado para uma placa FXO e no E1');

        DG_ERROR_FIFO_UNAVAILABLE:
          GeraLog(j,'Erro na criao da estrutura de comunicao da thread');

        DG_ERROR_COULD_NOT_CREATE_THREAD:
          GeraLog(j,'Falha na inicializao da thread');

      end;
    end;

    for i:=1 to vlib4.GetCardsCount do
    begin
      //Configura o sincronismo
      vlib4.SetCardSyncMode(i, SYNC_LINE_A);
      //Configura para que o evento OnE1Alarm ocorra automaticamente sempre quando um alarme for detectado
      vlib4.SetAlarmMode(i, ALARM_AUTOMATIC_NOTIFY);
    end;

    for k:=1 to vlib4.GetPortsCount do
    begin
      //Categoria do Assinante
      vlib4.ConfigE1Thread(k, E1CFG_GROUP_II,1);
      //Seta o Bina
      vlib4.SetPortID(k, '1121916363');
      //Numero total de digitos a receber
      vlib4.ConfigE1Thread(k, E1CFG_MAXDIGITS_RX,4);
      //Status Grupo B
      vlib4.ConfigE1Thread(k, E1CFG_GROUP_B,1);
      //Em ligacoes de entrada, pede bina apos o 2 digito
      vlib4.ConfigE1Thread(k, E1CFG_SEND_ID_AFTERDIGIT,2);
    end;

  except
    Application.MessageBox('Erro na Criao das Threads E1', 'Except', mb_OK);
  end;

end;

procedure TForm1.btnDisableClick(Sender: TObject);
var
  i : Integer;
begin
  try
    for i:=1 to vlib4.GetPortsCount do
    begin
      //Destroi as Threads
      if vlib4.DestroyE1Thread(i) <> DG_EXIT_SUCCESS then
        GeraLog(i,'Erro ao destruir Thread E1')
      else
        GeraLog(i,'Fechou Thread E1') ;
    end;

  except
    Application.MessageBox('Erro ao Destruir as Threads E1', 'Except', mb_OK);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  cVersao : array[0..255] of Char;
  nRet : Integer;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib4.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    GeraLog(0,'Verso DLL -> ' + cVersao)
  else
    GeraLog(0,'Verso DLL -> Falha');

  nRet := vlib4.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    GeraLog(0,'Verso OCX -> ' + cVersao)
  else
    GeraLog(0,'Verso OCX -> Falha');

end;

end.


